'Rectagular to Polar Coordinates
'(Feb. 13, 2001)
'By Achilles Mina

'You can do as you please with this code.

$INCLUDE "RAPIDQ.INC"

DECLARE FUNCTION SetFocus LIB "USER32" ALIAS "SetFocus" (HWnd AS LONG) AS LONG
DECLARE SUB preRecPolar
DECLARE SUB RecPolar(key AS BYTE)
DECLARE SUB PRRadio

CREATE ArialG AS QFONT
    Name = "Arial"
    Color = clBlack '&HEEFE   
    AddStyles(fsBold)
    Size = 12
END CREATE

CREATE TimeFont AS QFONT
    Name = "Univers"
    Color = clGreen
    Size = 12
    AddStyles(fsBold)
END CREATE

CREATE Arial9B AS QFONT
    Name = "Arial"
    Color = clBlack
    AddStyles(fsBold)
    Size = 9
END CREATE

  CREATE CoordForm AS QFORM    
    Center
    Caption = "Coordinate Systems"
    Width = 237
    Height = 205
    Color = &HABC111
    DelBorderIcons(biMaximize)
    BorderStyle = bsSingle
    CREATE RectPolarB AS QRADIOBUTTON
      Left = 10
      Top = 10
      Checked = 1
      OnClick = PRRadio
    END CREATE
    CREATE PolarRectB AS QRADIOBUTTON
      Left = 205
      Top = 10
      Checked = 0
      OnClick = PRRadio
    END CREATE
    CREATE PolarRect AS QPANEL
      Left = 25
      Top = 8
      Width = 180
      Height = 20
      Color = &HABC111
      BevelInner = bvNone
      BevelOuter = bvNone
      Bevelwidth = bvNone
      Font = Arial9B
      Caption = "< Rect to Polar   Polar to Rect >"
    END CREATE
    CREATE xRadius AS QEDIT
      Left = 10
      Top = 35
      Width = 65
      Height = 21
      TabOrder = 1
      OnKeyPress = RecPolar
    END CREATE
    CREATE xPanel AS QPANEL
      Font = ArialG
      Alignment = taLeftJustify
      Left = 76
      Top = 36
      Width = 20
      Height = 21
      Color = &HABC111
      BevelInner = bvNone
      BevelOuter = bvNone
      Bevelwidth = bvNone
      Caption = "x"
    END CREATE    
    CREATE yPanel AS QPANEL
      Font = ArialG
      Alignment = taRightJustify
      Left = 134
      Top = 36
      Width = 20
      Height = 21
      Color = &HABC111
      BevelInner = bvNone
      BevelOuter = bvNone
      Bevelwidth = bvNone
      Caption = "y"
    END CREATE
    CREATE yAngle AS QEDIT
      Left = 154
      Top = 35
      Width = 65
      Height = 21
      TabOrder = 3
      OnKeyPress = RecPolar
    END CREATE      
    CREATE CoordButt AS QBUTTON
      Font = Arial9B
      Caption = "Press to convert"
      Left = 10
      Top = 65
      Width = 210
      TabOrder = 6
      OnClick = preRecPolar
    END CREATE
    CREATE CoordPanel1 AS QPANEL
      Left = 10
      Top = 90
      Width = 210
      Color = Black
      Font = TimeFont
    END CREATE
    CREATE CoordPanel2 AS QPANEL
      Left = 10
      Top = 130
      Width = 210
      Color = Black
      Font = TimeFont
    END CREATE         
  END CREATE


SUB PRRadio
  xRadiusL = LEN(CoordPanel1.Caption)
  yRadiusL = LEN(CoordPanel2.Caption)
  IF RectPolarB.Checked = 1 THEN
    xPanel.Caption = "x"
    yPanel.Caption = "y"
    xRadius.Text = RIGHT$(CoordPanel1.Caption,(xRadiusL - 4))    
    yAngle.Text = RIGHT$(CoordPanel2.Caption,(yRadiusL - 4))
  ELSEIF PolarRectB.Checked = 1 THEN
    xPanel.Caption = "r"
    yPanel.Caption = ""
    xRadius.Text = RIGHT$(CoordPanel1.Caption,(xRadiusL - 4)) 
    yAngle.Text = RIGHT$(CoordPanel2.Caption,(yRadiusL - 4))
    yAngle.Text = LEFT$(yAngle.Text,INSTR(yAngle.Text," ")-1)   
  END IF
  RecPolar(13)
END SUB

SUB preRecPolar
  RecPolar(13)
END SUB

SUB RecPolar(key AS BYTE)
  IF key <> 13 THEN EXIT SUB
  x = VAL(xRadius.Text)
  y = VAL(yAngle.Text)
  IF x <> 0 THEN angle = ATAN(ABS(y/x))
  IF RectPolarB.Checked = 1 THEN
    IF x = 0 AND y = 0 THEN
       = 0
    ELSEIF x > 0 AND y > 0 THEN
       = angle
    ELSEIF x = 0 AND y > 0 THEN
       = 1.5707963267949
    ELSEIF x < 0 AND y > 0 THEN 
       = 3.14159265358979 - angle
    ELSEIF x < 0 AND y = 0 THEN
       = 3.14159265358979
    ELSEIF x < 0 AND y < 0 THEN 
       = 3.14159265358979 + angle
    ELSEIF x = 0 AND y < 0 THEN
       = 4.71238898038469
    ELSEIF x > 0 AND y < 0 THEN 
       = 6.28318530717958 - angle
    ELSEIF x > 0 AND y = 0 THEN
       = 0
    END IF
    r = SQR(y^2 + x^2)     
    CoordPanel1.Caption = "r = " + FORMAT$("%.4f",r)
    CoordPanel2.Caption = " = " + FORMAT$("%.4f",)+ " or " + FORMAT$("%.1f",57.2957795130824*) + ""
  ELSEIF PolarRectB.Checked = 1 THEN
    IF y = 1.5707963267949 THEN
      xcoord = 0
      ycoord = 1
    ELSEIF y = 0 THEN
      xcoord = 1
      ycoord = 0
    ELSE
      xcoord = ABS(x)*COS(y)
      ycoord = ABS(x)*SIN(y)
    END IF
    CoordPanel1.Caption = "x = " + STR$(xcoord)
    CoordPanel2.Caption = "y = " + STR$(ycoord)
  END IF 
END SUB

SetFocus(xRadius.Handle)
CoordForm.ShowModal